'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  }
}

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

var ENV_TYPE = {
  WEAPP: 'WEAPP',
  WEB: 'WEB',
  RN: 'RN'
};
function getEnv() {
  if (typeof wx !== 'undefined' && wx.getSystemInfo) {
    return ENV_TYPE.WEAPP;
  }

  if (typeof window !== 'undefined') {
    return ENV_TYPE.WEB;
  }

  if (typeof global !== 'undefined' && global.ErrorUtils) {
    return ENV_TYPE.RN;
  }

  return 'Unknown environment';
}
function isEmptyObject(obj) {
  if (!obj) {
    return false;
  }

  for (var n in obj) {
    if (obj.hasOwnProperty(n) && obj[n]) {
      return false;
    }
  }

  return true;
}
/**
 * JSON 克隆
 * @param {Object | Json} jsonObj json对象
 * @return {Object | Json} 新的json对象
 */

function objClone(jsonObj) {
  var buf;

  if (jsonObj instanceof Array) {
    buf = [];
    var i = jsonObj.length;

    while (i--) {
      buf[i] = objClone(jsonObj[i]);
    }

    return buf;
  } else if (jsonObj instanceof Object) {
    buf = {};

    for (var k in jsonObj) {
      buf[k] = objClone(jsonObj[k]);
    }

    return buf;
  } else {
    return jsonObj;
  }
}

var Component =
/*#__PURE__*/
function () {
  function Component(props) {
    _classCallCheck(this, Component);

    Object.defineProperty(this, "$components", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: {}
    });
    Object.defineProperty(this, "$$components", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: {}
    });
    Object.defineProperty(this, "$path", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: ''
    });
    Object.defineProperty(this, "$name", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: ''
    });
    Object.defineProperty(this, "$isComponent", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: true
    });
    Object.defineProperty(this, "$props", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: {}
    });
    Object.defineProperty(this, "defaultProps", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: {}
    });
    Object.defineProperty(this, "nextProps", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: {}
    });
    this.state = {};
    this.state = this._createData && this._createData() || {};
    this.props = props || {};
  }

  _createClass(Component, [{
    key: "_initData",
    value: function _initData($root, $parent) {
      var _this = this;

      this.$app = getApp();
      this.$root = $root || this;
      this.$parent = $parent || null;
      this.defaultData = {};
      this.$data = $parent ? $parent.$data : {};
      var path = this.$path.split('$$').pop();
      this.$data["$$".concat(path)] = this.$data["$$".concat(path)] || {};
      this.$data = this.$data["$$".concat(path)];

      for (var k in this.state) {
        this.$data[k] = this.state[k];
      }

      if (this.props) {
        for (var _k in this.props) {
          this.$data[_k] = this.props[_k];
        }
      }

      Object.getOwnPropertyNames(this.$$components).forEach(function (name) {
        _this.$$components[name]._initData(_this.$root, _this);
      });
    }
  }, {
    key: "_init",
    value: function _init(scope) {
      var _this2 = this;

      this.$scope = scope;
      this.$app = getApp();
      Object.getOwnPropertyNames(this.$$components).forEach(function (name) {
        _this2.$$components[name]._init(_this2.$scope);
      });
    } // rewrite when compile

  }, {
    key: "_createData",
    value: function _createData() {
      return this.state;
    }
  }, {
    key: "setState",
    value: function setState(state) {
      this._setState(state, true);
    }
  }, {
    key: "_setState",
    value: function _setState(state, update) {
      var newState = {};

      switch (_typeof(state)) {
        case 'function':
          newState = state(this.state, this.props);
          break;

        case 'object':
          newState = state;
          break;

        default:
          throw new Error('parameter error!');
      }

      if (this.shouldComponentUpdate(this.nextProps, newState)) {
        this.state = Object.assign(this.state, newState);
        this.lastProps = objClone(this.props);
        this.props = Object.assign(this.props, this.nextProps);
        this._createData && this._createData();

        for (var k in this.$props) {
          var newChildProps = this.$props[k]();
          this.$$components[k].componentWillReceiveProps(newChildProps);
          this.$$components[k].nextProps = newChildProps;

          this.$$components[k]._setState({}, false);
        }

        this.componentWillUpdate(this.lastProps, this.nextProps);
        Object.assign(this.$data, this.state, this.props);

        this._update(update);
      } else {
        this.state = Object.assign(this.state, newState);
        this._createData && this._createData();
        this.props = Object.assign(this.props, this.nextProps);
      }
    }
  }, {
    key: "_update",
    value: function _update(update) {
      var self = this;

      this.$scope._setData(_objectSpread({}, this.$root.$data), function (lastProps, props) {
        return function () {
          self.componentDidUpdate(lastProps, props);
        };
      }(this.lastProps, this.props), update);
    } // onLoad

  }, {
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this3 = this;

      Object.getOwnPropertyNames(this.$$components).forEach(function (name) {
        _this3.$$components[name].componentWillMount();
      });
    } // onReady

  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this4 = this;

      Object.getOwnPropertyNames(this.$$components).forEach(function (name) {
        _this4.$$components[name].componentDidMount();
      });
    } // onUnload

  }, {
    key: "componentDidUnmout",
    value: function componentDidUnmout() {
      var _this5 = this;

      Object.getOwnPropertyNames(this.$$components).forEach(function (name) {
        _this5.$$components[name].componentWillUnmout();
      });
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {}
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return true;
    }
  }, {
    key: "componentWillUpdate",
    value: function componentWillUpdate(lastProps, nextProps) {}
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(lastProps, nextProps) {} //  Not supported in component

  }, {
    key: "componentWillUnmout",
    value: function componentWillUnmout() {}
  }, {
    key: "onShow",
    value: function onShow() {}
  }, {
    key: "onHide",
    value: function onHide() {}
  }, {
    key: "onLaunch",
    value: function onLaunch() {}
  }]);

  return Component;
}();

/**
 * WXML节点信息API
 * @return {Object} SelectorQuery 对象实例
 */
function queryBat(queue, cb) {
  var res = [];
  var cached = {};
  queue.forEach(function (item) {
    var selector = item.selector,
        single = item.single,
        fields = item.fields;
    var el = null;

    if (single) {
      if (cached[selector] && cached[selector].single) {
        el = cached[selector].el;
      } else {
        el = document.querySelector(selector);
        cached[selector] = {
          single: single,
          el: el
        };
      }

      res.push(filter(fields, el, selector));
    } else {
      if (cached[selector] && !cached[selector].single) {
        el = cached[selector].el;
      } else {
        el = Array.from(document.querySelectorAll(selector));
        cached[selector] = {
          single: single,
          el: el
        };
      }

      res.push(el.map(function (dom) {
        return filter(fields, dom);
      }));
    }
  });
  cb(res);
}

function filter(fields, dom, selector) {
  if (!dom) return null;
  var id = fields.id,
      dataset = fields.dataset,
      rect = fields.rect,
      size = fields.size,
      scrollOffset = fields.scrollOffset,
      _fields$properties = fields.properties,
      properties = _fields$properties === void 0 ? [] : _fields$properties;

  var _dom$getBoundingClien = dom.getBoundingClientRect(),
      left = _dom$getBoundingClien.left,
      right = _dom$getBoundingClien.right,
      top = _dom$getBoundingClien.top,
      bottom = _dom$getBoundingClien.bottom,
      width = _dom$getBoundingClien.width,
      height = _dom$getBoundingClien.height;

  var isViewport = selector === 'html';
  var res = {};
  if (id) res.id = dom.id;
  if (dataset) res.dataset = Object.assign({}, dom.dataset);

  if (rect) {
    if (!isViewport) {
      res.left = left;
      res.right = right;
      res.top = top;
      res.bottom = bottom;
    } else {
      res.left = res.right = res.top = res.bottom = 0;
    }
  }

  if (size) {
    if (!isViewport) {
      res.width = width;
      res.height = height;
    } else {
      res.width = dom.clientWidth;
      res.height = dom.clientHeight;
    }
  }

  if (scrollOffset) {
    res.scrollLeft = dom.scrollLeft;
    res.scrollTop = dom.scrollTop;
  }

  if (properties.length) {
    properties.forEach(function (prop) {
      res[prop] = dom.getAttribute(prop);
    });
  }

  return res;
}

var Query =
/*#__PURE__*/
function () {
  function Query() {
    _classCallCheck(this, Query);

    this._defaultWebviewId = null;
    this._webviewId = null;
    this._queue = [];
    this._queueCb = [];
    this._component = null;
  }

  _createClass(Query, [{
    key: "in",
    value: function _in(component) {
      this._component = component;
      return this;
    }
  }, {
    key: "select",
    value: function select(selector) {
      // 小程序里跨自定义组件的后代选择器 '>>>' 在 h5 替换为普通后代选择器 '>'
      selector = selector.replace('>>>', '>');
      return new NodesRef(selector, this, true);
    }
  }, {
    key: "selectAll",
    value: function selectAll(selector) {
      // 小程序里跨自定义组件的后代选择器 '>>>' 在 h5 替换为普通后代选择器 '>'
      selector = selector.replace('>>>', '>');
      return new NodesRef(selector, this, false);
    }
  }, {
    key: "selectViewport",
    value: function selectViewport() {
      return new NodesRef('html', this, true);
    }
  }, {
    key: "exec",
    value: function exec(cb) {
      var _this = this;

      queryBat(this._queue, function (res) {
        var _queueCb = _this._queueCb;
        res.forEach(function (item, index) {
          typeof _queueCb[index] === 'function' && _queueCb[index].call(_this, item);
        });
        typeof cb === 'function' && cb.call(_this, res);
      });
    }
  }, {
    key: "_push",
    value: function _push(selector, component, single, fields) {
      var callback = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;

      this._queue.push({
        component: component,
        selector: selector,
        single: single,
        fields: fields
      });

      this._queueCb.push(callback);
    }
  }]);

  return Query;
}();

var NodesRef =
/*#__PURE__*/
function () {
  function NodesRef(selector, querySelectorQuery, single) {
    _classCallCheck(this, NodesRef);

    this._component = querySelectorQuery._component;
    this._selector = selector;
    this._selectorQuery = querySelectorQuery;
    this._single = single;
  }

  _createClass(NodesRef, [{
    key: "boundingClientRect",
    value: function boundingClientRect(cb) {
      var _selector = this._selector,
          _component = this._component,
          _single = this._single,
          _selectorQuery = this._selectorQuery;

      _selectorQuery._push(_selector, _component, _single, {
        id: !0,
        dataset: !0,
        rect: !0,
        size: !0
      }, cb);

      return _selectorQuery;
    }
  }, {
    key: "scrollOffset",
    value: function scrollOffset(cb) {
      var _selector = this._selector,
          _component = this._component,
          _single = this._single,
          _selectorQuery = this._selectorQuery;

      _selectorQuery._push(_selector, _component, _single, {
        id: !0,
        dataset: !0,
        scrollOffset: !0
      }, cb);

      return _selectorQuery;
    }
  }, {
    key: "fields",
    value: function fields(_fields, cb) {
      var _selector = this._selector,
          _component = this._component,
          _single = this._single,
          _selectorQuery = this._selectorQuery;
      var id = _fields.id,
          dataset = _fields.dataset,
          rect = _fields.rect,
          size = _fields.size,
          scrollOffset = _fields.scrollOffset,
          _fields$properties2 = _fields.properties,
          properties = _fields$properties2 === void 0 ? [] : _fields$properties2;

      _selectorQuery._push(_selector, _component, _single, {
        id: id,
        dataset: dataset,
        rect: rect,
        size: size,
        scrollOffset: scrollOffset,
        properties: properties
      }, cb);

      return _selectorQuery;
    }
  }]);

  return NodesRef;
}();

function createSelectorQuery() {
  return new Query();
}

var env = getEnv();
var RequestQueue = {
  MAX_REQUEST: 5,
  queue: [],
  request: function request(options) {
    this.push(options);
    this.run();
  },
  push: function push(options) {
    this.queue.push(options);
  },
  run: function run() {
    var _this = this,
        _arguments = arguments;

    if (!this.queue.length) {
      return;
    }

    if (this.queue.length <= this.MAX_REQUEST) {
      var options = this.queue.shift();
      var completeFn = options.complete;

      options.complete = function () {
        completeFn && completeFn.apply(options, _toConsumableArray(_arguments));

        _this.run();
      };

      wx.request(options);
    }
  }
};

function request(options) {
  options = options || {};

  if (typeof options === 'string') {
    options = {
      url: options
    };
  }

  if (env === ENV_TYPE.WEAPP) {
    var p = new Promise(function (resolve, reject) {
      options['success'] = function (res) {
        resolve(res.data);
      };

      options['fail'] = function (res) {
        reject(res);
      };

      RequestQueue.request(options);
    });
    return p;
  } else {
    var url = options.url;
    var params = {};
    params.body = options.data;
    params.headers = options.header;
    params.method = options.method;
    params.mode = options.mode;
    params.credentials = options.credentials;
    params.cache = options.cache;
    return fetch(url, params).then(function (response) {
      if (options.responseType === 'arraybuffer') {
        return response.arrayBuffer();
      }

      if (options.dataType === 'json' || typeof options.dataType === 'undefined') {
        return response.json();
      }

      if (options.responseType === 'text') {
        return response.text();
      }
    });
  }
}

function processApis(taro) {
  var onAndSyncApis = {
    onSocketOpen: true,
    onSocketError: true,
    onSocketMessage: true,
    onSocketClose: true,
    onBackgroundAudioPlay: true,
    onBackgroundAudioPause: true,
    onBackgroundAudioStop: true,
    onNetworkStatusChange: true,
    onAccelerometerChange: true,
    onCompassChange: true,
    onBluetoothAdapterStateChange: true,
    onBluetoothDeviceFound: true,
    onBLEConnectionStateChange: true,
    onBLECharacteristicValueChange: true,
    onBeaconUpdate: true,
    onBeaconServiceChange: true,
    onUserCaptureScreen: true,
    onHCEMessage: true,
    onGetWifiList: true,
    onWifiConnected: true,
    setStorageSync: true,
    getStorageSync: true,
    getStorageInfoSync: true,
    removeStorageSync: true,
    clearStorageSync: true,
    getSystemInfoSync: true,
    getExtConfigSync: true
  };
  var noPromiseApis = {
    // 媒体
    stopRecord: true,
    getRecorderManager: true,
    pauseVoice: true,
    stopVoice: true,
    pauseBackgroundAudio: true,
    stopBackgroundAudio: true,
    getBackgroundAudioManager: true,
    createAudioContext: true,
    createInnerAudioContext: true,
    createVideoContext: true,
    createCameraContext: true,
    // 位置
    createMapContext: true,
    // 设备
    canIUse: true,
    startAccelerometer: true,
    stopAccelerometer: true,
    startCompass: true,
    stopCompass: true,
    // 界面
    hideToast: true,
    hideLoading: true,
    showNavigationBarLoading: true,
    hideNavigationBarLoading: true,
    createAnimation: true,
    pageScrollTo: true,
    createSelectorQuery: true,
    createCanvasContext: true,
    createContext: true,
    drawCanvas: true,
    hideKeyboard: true,
    stopPullDownRefresh: true,
    // 拓展接口
    arrayBufferToBase64: true,
    base64ToArrayBuffer: true,
    getUpdateManager: true,
    createWorker: true
  };
  var otherApis = {
    // 网络
    uploadFile: true,
    downloadFile: true,
    connectSocket: true,
    sendSocketMessage: true,
    closeSocket: true,
    // 媒体
    chooseImage: true,
    previewImage: true,
    getImageInfo: true,
    saveImageToPhotosAlbum: true,
    startRecord: true,
    playVoice: true,
    getBackgroundAudioPlayerState: true,
    playBackgroundAudio: true,
    seekBackgroundAudio: true,
    chooseVideo: true,
    saveVideoToPhotosAlbum: true,
    // 文件
    saveFile: true,
    getFileInfo: true,
    getSavedFileList: true,
    getSavedFileInfo: true,
    removeSavedFile: true,
    openDocument: true,
    // 数据缓存
    setStorage: true,
    getStorage: true,
    getStorageInfo: true,
    removeStorage: true,
    clearStorage: true,
    // 位置
    getLocation: true,
    chooseLocation: true,
    openLocation: true,
    // 设备
    getSystemInfo: true,
    getNetworkType: true,
    makePhoneCall: true,
    scanCode: true,
    setClipboardData: true,
    getClipboardData: true,
    openBluetoothAdapter: true,
    closeBluetoothAdapter: true,
    getBluetoothAdapterState: true,
    startBluetoothDevicesDiscovery: true,
    stopBluetoothDevicesDiscovery: true,
    getBluetoothDevices: true,
    getConnectedBluetoothDevices: true,
    createBLEConnection: true,
    closeBLEConnection: true,
    getBLEDeviceServices: true,
    getBLEDeviceCharacteristics: true,
    readBLECharacteristicValue: true,
    writeBLECharacteristicValue: true,
    notifyBLECharacteristicValueChange: true,
    startBeaconDiscovery: true,
    stopBeaconDiscovery: true,
    getBeacons: true,
    setScreenBrightness: true,
    getScreenBrightness: true,
    setKeepScreenOn: true,
    vibrateLong: true,
    vibrateShort: true,
    addPhoneContact: true,
    getHCEState: true,
    startHCE: true,
    stopHCE: true,
    sendHCEMessage: true,
    startWifi: true,
    stopWifi: true,
    connectWifi: true,
    getWifiList: true,
    setWifiList: true,
    getConnectedWifi: true,
    // 界面
    showToast: true,
    showLoading: true,
    showModal: true,
    showActionSheet: true,
    setNavigationBarTitle: true,
    setNavigationBarColor: true,
    setTabBarBadge: true,
    removeTabBarBadge: true,
    showTabBarRedDot: true,
    hideTabBarRedDot: true,
    setTabBarStyle: true,
    setTabBarItem: true,
    showTabBar: true,
    hideTabBar: true,
    setTopBarText: true,
    switchTab: true,
    reLaunch: true,
    startPullDownRefresh: true,
    // 第三方平台
    getExtConfig: true,
    // 开放接口
    login: true,
    authorize: true,
    getUserInfo: true,
    requestPayment: true,
    showShareMenu: true,
    hideShareMenu: true,
    updateShareMenu: true,
    getShareInfo: true,
    chooseAddress: true,
    addCard: true,
    openCard: true,
    openSetting: true,
    getSetting: true,
    getWeRunData: true,
    navigateToMiniProgram: true,
    navigateBackMiniProgram: true,
    chooseInvoiceTitle: true,
    checkIsSupportSoterAuthentication: true,
    startSoterAuthentication: true,
    checkIsSoterEnrolledInDevice: true //

  };
  var weApis = Object.assign(onAndSyncApis, noPromiseApis, otherApis);
  Object.keys(weApis).forEach(function (key) {
    if (env === ENV_TYPE.WEAPP) {
      if (!onAndSyncApis[key] && !noPromiseApis[key]) {
        taro[key] = function (options) {
          var task = null;
          var obj = {};
          options = options || {};

          if (typeof options === 'string') {
            return wx[key](options);
          }

          var p = new Promise(function (resolve, reject) {
            ['fail', 'success', 'complete'].forEach(function (k) {
              obj[k] = function (res) {
                if (k === 'success') {
                  if (key === 'connectSocket') {
                    resolve(task);
                  } else {
                    resolve(res);
                  }
                } else if (k === 'fail') {
                  reject(res);
                }
              };
            });
            task = wx[key](obj);
          });

          if (key === 'uploadFile' || key === 'downloadFile') {
            p.progress = function (cb) {
              task.onProgressUpdate(cb);
              return p;
            };

            p.abort = function (cb) {
              cb && cb();
              task.abort();
              return p;
            };
          }

          return p;
        };
      } else {
        taro[key] = function () {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          return wx[key].apply(wx, args);
        };
      }
    } else {
      taro[key] = function () {
        console.log("\u6682\u65F6\u4E0D\u652F\u6301 ".concat(key));
      };
    }
  });
}

function initNativeApi(taro) {
  processApis(taro);
  taro.request = request;
  taro.createSelectorQuery = createSelectorQuery;
}

function createApp(appClass) {
  initNativeApi(this);
  var app = new appClass();
  var weappAppConf = {
    onLaunch: function onLaunch(options) {
      if (app.componentDidMount) {
        app.componentDidMount(options);
      }
    }
  };
  return Object.assign(weappAppConf, app);
}

var eventPreffix = '__event_';
var rootScopeKey = '__root_';
var scopeMap = {};

function processEvent(eventHandlerName, obj, page) {
  var newEventHandlerName = eventHandlerName.replace(eventPreffix, '');

  obj[newEventHandlerName] = function (event) {
    if (event) {
      event.preventDefault = function () {};

      event.stopPropagation = function () {};

      Object.assign(event.target, event.detail);
      Object.assign(event.currentTarget, event.detail);
    }

    var dataset = event.currentTarget.dataset;
    var scope = this;
    var bindArgs = {};
    Object.keys(dataset).forEach(function (key) {
      var newEventHandlerNameLower = newEventHandlerName.toLocaleLowerCase();

      if (key.indexOf(eventPreffix) >= 0 && key.indexOf(newEventHandlerNameLower) >= 0) {
        var argName = key.replace("".concat(eventPreffix).concat(newEventHandlerNameLower, "_"), '');
        bindArgs[argName] = dataset[key];
      }
    });

    if (!isEmptyObject(bindArgs)) {
      if (bindArgs['scope'] !== 'this') {
        scope = bindArgs['scope'];
      } else {
        if (dataset['__component_path']) {
          scope = scopeMap[dataset['__component_path'] || rootScopeKey];
        }
      }

      delete bindArgs['scope'];
      var realArgs = Object.keys(bindArgs).sort().map(function (key) {
        return bindArgs[key];
      });
      realArgs.push(event);

      var newHandler = function newHandler() {
        return page[eventHandlerName].apply(scope, realArgs);
      };

      newHandler();
    } else {
      if (dataset['__component_path']) {
        scope = scopeMap[dataset['__component_path'] || rootScopeKey];
      }

      page[eventHandlerName].call(scope, event);
    }
  }.bind(page);
}

function recurrenceComponent(weappPageConf, component, path) {
  component.$path = path || '';
  component.props.$path = component.$path;

  if (path) {
    scopeMap[path] = component;
  } else {
    scopeMap[rootScopeKey] = component;
  }

  !isEmptyObject(component.$components) && Object.getOwnPropertyNames(component.$components).forEach(function (name) {
    var _class = component.$components[name];
    var comPath = "".concat(component.$path, "$$").concat(name);

    var _props = (component.$props || {})[name] || {};

    var props = typeof _props === 'function' ? _props.call(component) : _props;
    var child = new _class(props);
    component.$$components[name] = child;
    recurrenceComponent(weappPageConf, child, comPath);
  });

  for (var k in component) {
    if (k.indexOf(eventPreffix) >= 0) {
      processEvent(k, weappPageConf, component);
    }
  }

  Object.getOwnPropertyNames(component.constructor.prototype).forEach(function (fn) {
    if (fn.indexOf(eventPreffix) >= 0) {
      processEvent(fn, weappPageConf, component);
    }
  });
  return weappPageConf;
}

function createPage(pageClass) {
  var page = new pageClass();
  page.$isComponent = false;
  var weappPageConf = {
    stateList: [],
    onLoad: function onLoad(options) {
      page._init(this);

      page.$router = {
        params: options
      };

      if (page.componentWillMount) {
        page.componentWillMount();
      }
    },
    onReady: function onReady() {
      if (page.componentDidMount) {
        page.componentDidMount();
      }
    },
    onUnload: function onUnload() {
      if (page.componentDidUnmount) {
        page.componentDidUnmount();
      }
    },
    _setData: function _setData(data, cb, isRoot) {
      this.stateList.push({
        data: data,
        cb: cb
      });

      if (isRoot) {
        var stateListTmp = this.stateList;
        this.stateList = [];
        this.setData(data, function () {
          stateListTmp.forEach(function (state) {
            state.cb && typeof state.cb === 'function' && state.cb();
          });
        });
      }
    }
  };
  var weappPageConfEvents = recurrenceComponent(weappPageConf, page);

  page._initData();

  return Object.assign(weappPageConfEvents, {
    data: page.$data
  });
}

var index = {
  Component: Component,
  createApp: createApp,
  createPage: createPage,
  initNativeApi: initNativeApi
};

exports.Component = Component;
exports.createApp = createApp;
exports.createPage = createPage;
exports.initNativeApi = initNativeApi;
exports.default = index;
//# sourceMappingURL=index.js.map
